#pragma once

#include "widget.h"

#include <SFML/Graphics/RectangleShape.hpp>

class MenuButton : public Widget
{
public:
    explicit MenuButton(std::string&& text);

    virtual void input(const sf::Event& event) = 0;
    virtual void update() = 0;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const = 0;
    virtual void setRect(const sf::FloatRect& rect) = 0;
    virtual void setPosition(const sf::Vector2f& position) = 0;
    virtual bool isUnderMouse(int mouse_x, int mouse_y) const = 0;

    virtual bool isActive() const = 0;
    virtual void setActive(bool is_active) = 0;
    virtual void setHovered(bool is_hovered) = 0;
};
